' ---------------------------------------------
' base collision response routines
' ---------------------------------------------

' base response
Type ICOLLISION_RESPONSE Abstract
	Field _response:Int
	
	' responds to the collision
	Method OnCollision(col:COLLISION) Abstract
EndType

Type RESPONSE_STOP Extends ICOLLISION_RESPONSE
	Method OnCollision(col:COLLISION)
		col._entity.Position(col._entity.getLastPosition().getX(),col._entity.getLastPosition().getY(),col._entity.getLastPosition().getZ())
	EndMethod
EndType

' irrlicht-based collision response
Type ICOLLISION_RESPONSE_IRRLICHT Extends ICOLLISION_RESPONSE Abstract
	Field _slide:Float=0.0005
	Field _gravity:Vector3df=Vector3df.createFromVals(0,-.5,0)	

	Method setSlideSpeed(speed:Float=0.0005)
		_slide=speed
	EndMethod
			
	Method setGravity(gravity:Vector3df)
		If gravity And gravity.IsValid() Then _gravity=gravity Else _gravity=Vector3df.createFromVals(0,-.5,0)
	EndMethod
EndType

Type RESPONSE_SLIDE_LIMITED_IRRLICHT Extends ICOLLISION_RESPONSE_IRRLICHT
	
	Method OnCollision(col:COLLISION)
		If col._position Then 
			Local position:Vector3df=col._position
			col._entity.setLastPosition()
			' if we arent falling and Y is less, then we assume we are sliding and set Y to last Y
			If Not col._falling And position.getY()<col._entity.getLastPosition().getY() Then position.setY(col._entity.getLastPosition().getY())
			col._entity.Position(position.getX(),position.getY(),position.getZ())
		Else
			col._entity.Position(col._entity.getLastPosition().getX(),col._entity.getLastPosition().getY(),col._entity.getLastPosition().getZ())
		EndIf
	EndMethod
EndType

Type RESPONSE_SLIDE_FULL_IRRLICHT Extends ICOLLISION_RESPONSE_IRRLICHT
	
	Method OnCollision(col:COLLISION)
		If col._position Then 
			col._entity.setLastPosition()
			col._entity.Position(col._position.getX(),col._position.getY(),col._position.getZ())
		Else
			col._entity.Position(col._entity.getLastPosition().getX(),col._entity.getLastPosition().getY(),col._entity.getLastPosition().getZ())
		EndIf
	EndMethod
EndType


