'  ------------------------------------------------------------------------------------
'  irr::core::array<u16> wrappers
'  NOTES:
'  - for regular data types use Var IrrCore_() to get the actual value
'  - did not implement:
	'Function IrrCore_Array_u16_const_pointer:Int Ptr(parray_u16_arr:Int)
	'Function IrrCore_Array_u16_pointer:Int Ptr(parray_u16_arr:Int)
	'Function IrrCore_Array_u16_set_pointer(parray_u16_arr:Int,newPointer:Int Ptr,size:Int)
'  ------------------------------------------------------------------------------------

Public

Type Array_u16 Extends IrrBase Final


	'--------------------------------------------
	' create/delete routines
	'--------------------------------------------

	Function createWithSize:Array_u16(start_count:Int)
		Return createFromHandle(IrrCore_Array_u16_newWithSize(start_count))
	EndFunction
	
	Function createFromOther:Array_u16(other:Array_u16)
		Return createFromHandle(IrrCore_Array_u16_newFromOther(other.handle))
	EndFunction

	Function create:Array_u16()
		Return createFromHandle(IrrCore_Array_u16_new())
	EndFunction
	
	Function createFromHandle:Array_u16(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:Array_u16=New Array_u16
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrCore_Array_u16_del(handle)
	EndMethod	

	'--------------------------------------------
	' the rest
	'--------------------------------------------

	Method allocated_size:Int()
		Return IrrCore_Array_u16_allocated_size(handle)
	EndMethod

	Method clear()
		IrrCore_Array_u16_clear(handle)
	EndMethod

	Method empty:Int()
		Return IrrCore_Array_u16_empty(handle)
	EndMethod
	
	Method eraseWithCount(idx:Int,count:Int)
		IrrCore_Array_u16_eraseWithCount(handle,idx,count)
	EndMethod
	
	Method erase(idx:Int)
		IrrCore_Array_u16_erase(handle,idx)
	EndMethod
	
	Method getLast:Short Ptr()
		' TODO: look into this
		'Return Var IrrCore_Array_u16_getLast(handle)
		Return IrrCore_Array_u16_getLast(handle)
	EndMethod
	
	Method elementAt:Short Ptr(idx:Int)
		' TODO: look into this
		'Return Var IrrCore_Array_u16_elementAt(handle,idx)
		Return IrrCore_Array_u16_elementAt(handle,idx)
	EndMethod
	
	Method insert(element:Short,idx:Int=0)
		IrrCore_Array_u16_insert(handle,Varptr(element),idx)
	EndMethod
	
	Method Eq(other:Array_u16)
		IrrCore_Array_u16_Eq(handle,other.handle)
	EndMethod

	Method push_back(element:Short)
		IrrCore_Array_u16_push_back(handle,Varptr(element))
	EndMethod
	
	Method push_front(element:Short)
		IrrCore_Array_u16_push_front(handle,Varptr(element))
	EndMethod

	Method reallocate(new_size:Int)
		IrrCore_Array_u16_reallocate(handle,new_size)
	EndMethod
	
	Method set_free_when_destroyed(bNewVal:Int)
		IrrCore_Array_u16_set_free_when_destroyed(handle,bNewVal)
	EndMethod

	Method set_sorted(bVal:Int)
		IrrCore_Array_u16_set_sorted(handle,bVal)
	EndMethod
	
	Method set_used(used:Int)
		IrrCore_Array_u16_set_used(handle,used)
	EndMethod
	
	Method size:Int()
		Return IrrCore_Array_u16_size(handle)
	EndMethod

	Method linear_reverse_search:Int(find:Short)
		Return IrrCore_Array_u16_linear_reverse_search(handle,Varptr(find))
	EndMethod

	Method linear_search:Int(find:Short)
		Return IrrCore_Array_u16_linear_search(handle,Varptr(find))
	EndMethod

	Method binary_search:Int(find:Short)
		Return IrrCore_Array_u16_binary_search(handle,Varptr(find))
	EndMethod

	Method binary_searchWithBounds:Int(find:Short,nLeft:Int,nRight:Int)
		Return IrrCore_Array_u16_binary_searchWithBounds(handle,Varptr(find),nLeft,nRight)
	EndMethod

	Method sort()
		IrrCore_Array_u16_sort(handle)
	EndMethod
	
EndType



