' ------------------------------------------------------------------------------------
' irr::core::plane3df wrappers (done)
' ------------------------------------------------------------------------------------

Public 

Type Plane3df Extends IrrBase Final

	Method EqEq:Int(pOther:Plane3df)
		Return IrrCore_Plane3df_EqEq(handle,pOther.handle)
	EndMethod

	Method NotEq:Int(pOther:Plane3df)
		Return IrrCore_Plane3df_NotEq(handle,pOther.handle)
	EndMethod
	
	Method getMemberPoint:Vector3df()
		' set to not delete
		Return Vector3df.createFromHandle(IrrCore_Plane3df_getMemberPoint(handle),False)
	EndMethod
	
	Method getDistanceTo:Float(pPoint:Vector3df)	
		Return IrrCore_Plane3df_getDistanceTo(handle,pPoint.handle)
	EndMethod
	
	Method getD:Float()
		Return IrrCore_Plane3df_getD(handle)
	EndMethod
	
	Method getNormal:Vector3df()
		Return Vector3df.createFromHandle(IrrCore_Plane3df_getNormal(handle))
	EndMethod

	Method isFrontFacing:Int(pLookDirection:Vector3df)
		Return IrrCore_Plane3df_isFrontFacing(handle,pLookDirection.handle)
	EndMethod
	
	Method classifyPointRelation:Int(pPoint:Vector3df)
		Return IrrCore_Plane3df_classifyPointRelation(handle,pPoint.handle)
	EndMethod
	
	Method recalculateD(pMPoint:Vector3df) 
		IrrCore_Plane3df_recalculateD(handle,pMPoint.handle)
	EndMethod

	Method getIntersectionWithLine:Int(pLinePoint:Vector3df,pLineVect:Vector3df,pOutIntersection:Vector3df)
		Return IrrCore_Plane3df_getIntersectionWithLine(handle,pLinePoint.handle,pLineVect.handle,pOutIntersection.handle)
	EndMethod
	
	Method existsIntersection:Int(pOther:Plane3df)
		Return IrrCore_Plane3df_existsIntersection(handle,pOther.handle)
	EndMethod
	
	Method getIntersectionWithPlane:Int(pOther:Plane3df,pOutLinePoint:Vector3df,pOutLineVect:Vector3df)	
		Return IrrCore_Plane3df_getIntersectionWithPlane(handle,pOther.handle,pOutLinePoint.handle,pOutLineVect.handle)
	EndMethod
	
	Method getIntersectionWithPlanes:Int(pO1:Plane3df,pO2:Plane3df,pOutPoint:Vector3df)
		Return IrrCore_Plane3df_getIntersectionWithPlanes(handle,pO1.handle,pO2.handle,pOutPoint.handle)
	EndMethod
	
	Method getIntersectionWithLimitedLine:Int(pLinePoint1:Vector3df,pLinePoint2:Vector3df,pOutIntersection:Vector3df)
		Return IrrCore_Plane3df_getIntersectionWithLimitedLine(handle,pLinePoint1.handle,pLinePoint2.handle,pOutIntersection.handle)
	EndMethod

	'--------------------------------------------
	' set routines
	'--------------------------------------------

	Method setPlaneFromPoints(pPoint1:Vector3df,pPoint2:Vector3df,pPoint3:Vector3df)
		IrrCore_Plane3df_setPlaneFromPoints(handle,pPoint1.handle,pPoint2.handle,pPoint3.handle)
	EndMethod

	Method setPlaneFromPointVect(pPoint:Vector3df,pVect:Vector3df)
		IrrCore_Plane3df_setPlaneFromPointVect(handle,pPoint.handle,pVect.handle)
	EndMethod
	
	Method setPlaneFromVectVal(pVect:Vector3df,d:Float)
		IrrCore_Plane3df_setPlaneFromVectVal(handle,pVect.handle,d)
	EndMethod

	'--------------------------------------------
	' create/delete routines
	'--------------------------------------------

	Function create:Plane3df()
		Return createFromHandle(IrrCore_Plane3df_new())
	EndFunction
	
	Function createNewFromVals:Plane3df(px:Float,py:Float,pz:Float,nx:Float,ny:Float,nz:Float)
		Return createFromHandle(IrrCore_Plane3df_newFromVals(px,py,pz,nx,ny,nz))
	EndFunction
	
	Function createNewFromPoints:Plane3df(pPoint1:Vector3df,pPoint2:Vector3df,pPoint3:Vector3df)
		Return createFromHandle(IrrCore_Plane3df_newFromPoints(pPoint1.handle,pPoint2.handle,pPoint3.handle))
	EndFunction
	
	Function createNewFromPlane:Plane3df(pPlane:Plane3df)
		Return createFromHandle(IrrCore_Plane3df_newFromPlane(pPlane.handle))
	EndFunction
	
	Function createNewFromPointNormal:Plane3df(pPoint:Vector3df,pNormal:Vector3df)
		Return createFromHandle(IrrCore_Plane3df_newFromPointNormal(pPoint.handle,pNormal.handle))
	EndFunction

	Function createNewFromNormal:Plane3df(normal:Vector3df, d:Float)
		Return createFromHandle(IrrCore_Plane3df_newFromNormal(normal.handle, d), True)
	EndFunction
		
	Function createFromHandle:Plane3df(pPlane:Int,bMustDel:Int=True)
		If Not pPlane Then Return Null
		Local oRetVal:Plane3df=New Plane3df
		oRetVal.attach(pPlane,bMustDel)
		Return oRetVal
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrCore_Plane3df_del(handle)
	EndMethod	
	
EndType