' ------------------------------------------------------------------------------------
' irr::core::stringc wrappers
' ------------------------------------------------------------------------------------
Public

Type StringC Extends IrrBase Final

	Method EqEqStringC:Int(pOther:StringC)
		Return IrrCore_StringC_EqEqStringC(handle,pOther.handle)
	EndMethod

	Method EqEq:Int(other:String)
		Return IrrCore_StringC_EqEq(handle,other)
	EndMethod

	Method NotEq:Int(pOther:StringC)
		Return IrrCore_StringC_NotEq(handle,pOther.handle)
	EndMethod
	
	Method Less:Int(pOther:StringC)
		Return IrrCore_StringC_Less(handle,pOther.handle)
	EndMethod

	Method PlusEqChar(char:Byte)
		IrrCore_StringC_PlusEqChar(handle,char)
	EndMethod
	
	Method PlusEqString(pOther:StringC)
		IrrCore_StringC_PlusEqString(handle,pOther.handle)
	EndMethod
	
	Method PlusEqInt(i:Int)
		IrrCore_StringC_PlusEqInt(handle,i)
	EndMethod

	Method Eq(pOther:StringC)
		IrrCore_StringC_Eq(handle,pOther.handle)
	EndMethod

	Method EqStringPtr(pOther:Byte Ptr)
		IrrCore_StringC_EqStringPtr(handle,pOther)
	EndMethod

	Method EqString(str:String)
		IrrCore_StringC_EqStringPtr(handle,str.ToCString())
	EndMethod

	Method PlusStringPtr:StringC(pOther:Byte Ptr)
		Return createFromHandle(IrrCore_StringC_PlusStringPtr(handle,pOther))
	EndMethod
	
	Method Plus:StringC(pOther:StringC)
		Return createFromHandle(IrrCore_StringC_Plus(handle,pOther.handle))
	EndMethod

	Method idx:Byte(idx:Int)
		Return IrrCore_StringC_idx(handle,idx)
	EndMethod

	Method idx_s:String(idx:Int)
		Return Chr(IrrCore_StringC_idx(handle,idx))
	EndMethod

	Method equals_ignore_case:Int(pOther:StringC)
		Return IrrCore_StringC_equals_ignore_case(handle,pOther.handle)
	EndMethod

	Method equalsnStringC:Int(pOther:StringC,strlen:Int)
		Return IrrCore_StringC_equalsnStringC(handle,pOther.handle,strlen)
	EndMethod

	Method equalsn:Int(other:String,strlen:Int)
		Return IrrCore_StringC_equalsn(handle,other,strlen)
	EndMethod

	Method reserve(count:Int)
		IrrCore_StringC_reserve(handle,count)
	EndMethod

	Method findFirst:Int(char:Byte)
		Return IrrCore_StringC_findFirst(handle,char)
	EndMethod
	
	Method findNext:Int(char:Byte,startpos:Int)
		Return IrrCore_StringC_findNext(handle,char,startpos)
	EndMethod

	Method findLast:Int(char:Byte)
		Return IrrCore_StringC_findLast(handle,char)
	EndMethod
	
	Method find:Int(other:String)
		Return IrrCore_StringC_find(handle,other)
	EndMethod
	
	Method subString:StringC(begin:Int,length:Int)
		Return createFromHandle(IrrCore_StringC_subString(handle,begin,length))
	EndMethod
	
	Method appendString(str:String)
		IrrCore_StringC_appendStringC(handle,createFromString(str).handle)
	EndMethod

	Method appendStringWithLength(str:String,length:Int)
		IrrCore_StringC_appendStringCWithLength(handle,createFromString(str).handle,length)
	EndMethod

	Method appendChar(char:Byte)
		IrrCore_StringC_appendChar(handle,char)
	EndMethod
	
	Method appendStringC(pOther:StringC)
		IrrCore_StringC_appendStringC(handle,pOther.handle)
	EndMethod

	Method appendStringCWithLength(pOther:StringC,length:Int)
		IrrCore_StringC_appendStringCWithLength(handle,pOther.handle,length)
	EndMethod

	Method getString:String()
		Return String.FromCString(c_str())
	EndMethod
	
	Method c_str:Byte Ptr()
		Return IrrCore_StringC_c_str(handle)
	EndMethod

	Method make_lower()
		IrrCore_StringC_make_lower(handle)
	EndMethod

	Method make_upper()
		IrrCore_StringC_make_upper(handle)
	EndMethod

	Method size:Int()
		Return IrrCore_StringC_size(handle)
	EndMethod

	Method PlusEqCharString(other:Byte Ptr)
		IrrCore_StringC_PlusEqcharString(handle,other)
	EndMethod
	
	Method PlusEqDouble(i:Double)
		IrrCore_StringC_PlusEqDouble(handle,i)
	EndMethod
	
	Method appendCharString(other:Byte Ptr)
		IrrCore_StringC_appendCharString(handle,other)
	EndMethod

	'--------------------------------------------
	' create/delete routines
	'--------------------------------------------

	Function createFromString:StringC(str:String)
		Return createFromStringPtr(str.ToCString())
	EndFunction

	Function createFromStringC:StringC(pOther:StringC)
		Return createFromHandle(IrrCore_StringC_newFromStringC(pOther.handle))
	EndFunction
	
	Function createFromInt:StringC(number:Int)
		Return createFromHandle(IrrCore_StringC_newFromInt(number))
	EndFunction
	
	Function createFromStringPtr:StringC(pOther:Byte Ptr)
		Return createFromHandle(IrrCore_StringC_newFromStringPtr(pOther))
	EndFunction

	Function createFromStringPtrWithLength:StringC(pOther:Byte Ptr,length:Int)
		Return createFromHandle(IrrCore_StringC_newFromStringPtrWithLength(pOther,length))
	EndFunction

	Function create:StringC()
		Return createFromHandle(IrrCore_StringC_new())
	EndFunction
		
	Function createFromHandle:StringC(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:StringC=New StringC
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrCore_StringC_del(handle)
	EndMethod	

EndType