' ------------------------------------------------------------------------------------
'  irr::gui::IGUIFont wrappers
'  do Not Delete a pointer To this
' ------------------------------------------------------------------------------------
Public

'//! An enum for the different types of GUI font.
'enum EGUI_FONT_TYPE
Const EGFT_BITMAP:Int = 0
Const EGFT_VECTOR:Int = 1
Const EGFT_OS:Int = 2
Const EGFT_CUSTOM:Int = 3

Type IGUIFont Extends IReferenceCounted

	Function createFromHandle:IGUIFont(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:IGUIFont=New IGUIFont
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
	
	Method getCharacterFromPos:Int(text:String,pixel_x:Int)
		Return IrrGUI_IGUIFont_getCharacterFromPos(handle,text,pixel_x)
	EndMethod
	
	Method getDimension:Dimension2di(text:String)
		Return Dimension2di.createFromHandle(IrrGUI_IGUIFont_getDimension(handle,text))
	EndMethod
	
	Method draw(text:String,pos:Recti,color:SColor,bHcenter:Int=False,bVcenter:Int=False,clip:Recti=Null)
		If clip=Null Then clip=New Recti ' default handle to 0
		IrrGUI_IGUIFont_draw(handle,text,pos.handle,color.handle,bHcenter,bVcenter,clip.handle)
	EndMethod

	Method getType:Int() ' returns EGUI_FONT_TYPE
		Return IrrGUI_IGUIFont_getType(handle)
	EndMethod
	
	Method setKerningWidth(kerning:Int)
		IrrGUI_IGUIFont_setKerningWidth(handle,kerning)
	EndMethod
	
	Method setKerningHeight(kerning:Int)
		IrrGUI_IGUIFont_setKerningHeight(handle,kerning)
	EndMethod
	
	Method getKerningWidth:Int(thisLetter:String=Null,previousLetter:String=Null)
		Return IrrGUI_IGUIFont_getKerningWidth(handle,thisLetter,previousLetter)
	EndMethod
	
	Method getKerningHeight:Int()
		Return IrrGUI_IGUIFont_getKerningHeight(handle)
	EndMethod

	Method setInvisibleCharacters(s:String)
		IrrGUI_IGUIFont_setInvisibleCharacters(handle, s)
	EndMethod

	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrGUI_IGUIFont_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrGUI_IGUIFont_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrGUI_IGUIFont_grab(handle)
	EndMethod
	
	Method Delete()
		If (mustdelete) Then drop()
	EndMethod

EndType


