Public

'//------------------------------------------------------------------------------------
'// SGUISpriteFrame
'//------------------------------------------------------------------------------------

Type SGUISpriteFrame Extends IrrBase Final
	
	Function createFromHandle:SGUISpriteFrame(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:SGUISpriteFrame=New SGUISpriteFrame
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method setTextureNumber(textureNumber:Int)
		IrrGUI_SGUISpriteFrame_setTextureNumber(handle,textureNumber)
	EndMethod
	
	Method getTextureNumber:Int()
		Return IrrGUI_SGUISpriteFrame_getTextureNumber(handle)
	EndMethod
	
	Method setRectNumber(rectNumber:int)
		IrrGUI_SGUISpriteFrame_setRectNumber(handle,rectNumber)
	EndMethod
	
	Method getRectNumber:Int()
		Return IrrGUI_SGUISpriteFrame_getRectNumber(handle)
	EndMethod
	
EndType

'//------------------------------------------------------------------------------------
'// SGUISprite
'//------------------------------------------------------------------------------------

Type SGUISprite Extends IrrBase Final

	Function createFromHandle:SGUISprite(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:SGUISprite=New SGUISprite
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method getFrameCount:Int()
		Return IrrGUI_SGUISprite_getFrameCount(handle)
	EndMethod
	
	Method getFrame:SGUISpriteFrame(frameNumber:Int)
		Return SGUISpriteFrame.createFromHandle(IrrGUI_SGUISprite_getFrame(handle,frameNumber),False)
	EndMethod
	
	Method getFrameTime:Int()
		Return IrrGUI_SGUISprite_getFrameTime(handle)
	EndMethod
	
	Method setFrameTime(frameTime:Int)
		IrrGUI_SGUISprite_setFrameTime(handle,frameTime)
	EndMethod
	
EndType

'//------------------------------------------------------------------------------------
'// SGUISpriteBank
'//------------------------------------------------------------------------------------

Type IGUISpriteBank Extends IReferenceCounted Final

	Function createFromHandle:IGUISpriteBank(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:IGUISpriteBank=New IGUISpriteBank
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction	

	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrGUI_IGUISpriteBank_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrGUI_IGUISpriteBank_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrGUI_IGUISpriteBank_grab(handle)
	EndMethod

	Method getPositions:Recti[]()
		Local pos_ptr:Int Ptr	
		Local positions:Recti[]=Null				

		Local size:Int=IrrGUI_IGUISpriteBank_getPositions(handle,Varptr(pos_ptr))
		
		If size>0 Then		
			positions=New Recti[size]

			For Local i:Int=0 Until size
				positions[i]=Recti.createFromHandle(pos_ptr[i],False)
			Next
		EndIf
		
		Irr_ptrarray_delete(Varptr(pos_ptr))
		
		Return positions
	EndMethod
	
	Method getSprites:SGUISprite[]()
		Local pos_ptr:Int Ptr	
		Local sprites:SGUISprite[]=Null				

		Local size:Int=IrrGUI_IGUISpriteBank_getSprites(handle,Varptr(pos_ptr))

		If size>0 Then		
			sprites=New SGUISprite[size]

			For Local i:Int=0 Until size
				sprites[i]=SGUISprite.createFromHandle(pos_ptr[i],False)
			Next
		EndIf
		
		Irr_ptrarray_delete(Varptr(pos_ptr))
		
		Return sprites	
	EndMethod

	Method getTextureCount:Int()
		Return IrrGUI_IGUISpriteBank_getTextureCount(handle)
	EndMethod
	
	Method getTexture:ITexture(index:Int)
		Return ITexture.createFromHandle(IrrGUI_IGUISpriteBank_getTexture(handle,index),False)
	EndMethod
	
	Method addTexture(texture:ITexture)
		IrrGUI_IGUISpriteBank_addTexture(handle,texture.handle)
	EndMethod
	
	Method setTexture(index:Int,texture:ITexture)
		IrrGUI_IGUISpriteBank_setTexture(handle,index,texture.handle)
	EndMethod
	
	Method draw2DSprite(index:Int,pos:Position2di,clip:Recti=Null,color:SColor=Null,starttime:Int=0,currenttime:Int=0,bLoop:Int=True,bCenter:Int=False)		
		IrrGUI_IGUISpriteBank_draw2DSprite(handle,index,pos.handle,_HANDLE(clip),_HANDLE(color),starttime,currenttime,bLoop,bCenter)
	EndMethod
	
	Method draw2DSpriteBatch(indices:Int[], pos:Position2di[], clip:Recti = Null, color:SColor = Null, starttime:Int = 0, currenttime:Int = 0, bLoop:Int = True, bCenter:Int = False)

		Local indices_size:Int = 0
		If indices Then indices_size = indices.Dimensions()[0]

		Local pos_size:Int = 0
		Local pos_array:Int[] = GetHandleArray(pos)
		If pos_array Then pos_size = pos_array.Dimensions()[0]
		
		IrrGUI_IGUISpriteBank_draw2DSpriteBatch(handle, indices, indices_size, pos_array, pos_size, _HANDLE(clip), _HANDLE(color), starttime, currenttime, bLoop, bCenter)
	EndMethod
	
EndType
