
Public

Type IGUITable Extends IGUIElement Final

	Function createFromHandle:IGUITable(pHandle:Int, bMustDel:Int = False, pGenFunc:Byte Ptr = Null)
		If Not pHandle Then Return Null
		Local oRetVal:IGUITable = New IGUITable
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method addColumn(caption:String, columnIndex:Int = -1)
		IrrGUI_IGUITable_addColumn(handle, StringToWChar(caption), columnIndex)
	EndMethod
	
	Method removeColumn(columnIndex:Int)
		IrrGUI_IGUITable_removeColumn(handle, columnIndex)
	EndMethod
	
	Method getColumnCount:Int()
		Return IrrGUI_IGUITable_getColumnCount(handle)
	EndMethod
	
	Method setActiveColumn:Int(idx:Int, bDoOrder:Int = False)
		Return IrrGUI_IGUITable_setActiveColumn(handle, idx, bDoOrder)
	EndMethod
	
	Method getActiveColumn:Int()
		Return IrrGUI_IGUITable_getActiveColumn(handle)
	EndMethod
	
	Method getActiveColumnOrdering:Int() ' returns EGUI_ORDERING_MODE 
		Return IrrGUI_IGUITable_getActiveColumnOrdering(handle) 
	EndMethod
	
	Method setColumnWidth(columnIndex:Int, width:Int)
		IrrGUI_IGUITable_setColumnWidth(handle, columnIndex, width)
	EndMethod
	
	Method setResizableColumns(bResizable:Int)
		IrrGUI_IGUITable_setResizableColumns(handle, bResizable)
	EndMethod
	
	Method hasResizableColumns:Int()
		Return IrrGUI_IGUITable_hasResizableColumns(handle)
	EndMethod
	
	Method setColumnOrdering(columnIndex:Int, EGUI_COLUMN_ORDERING:Int)
		IrrGUI_IGUITable_setColumnOrdering(handle, columnIndex, EGUI_COLUMN_ORDERING)
	EndMethod
	
	Method getSelected:Int()
		Return IrrGUI_IGUITable_getSelected(handle)
	EndMethod

	Method setSelected(index:Int)
		IrrGUI_IGUITable_setSelected(handle, index)
	EndMethod
	
	Method getRowCount:Int()
		Return IrrGUI_IGUITable_getRowCount(handle)
	EndMethod
	
	Method addRow:Int(rowIndex:Int)
		Return IrrGUI_IGUITable_addRow(handle, rowIndex)
	EndMethod
	
	Method removeRow(rowIndex:Int)
		IrrGUI_IGUITable_removeRow(handle, rowIndex)
	EndMethod
	
	Method clearRows()
		IrrGUI_IGUITable_clearRows(handle)
	EndMethod
	
	Method swapRows(rowIndexA:Int, rowIndexB:Int)
		IrrGUI_IGUITable_swapRows(handle, rowIndexA, rowIndexB)
	EndMethod
	
	Method orderRows(columnIndex:Int = -1, EGUI_ORDERING_MODE:Int = EGOM_NONE)
		IrrGUI_IGUITable_orderRows(handle, columnIndex, EGUI_ORDERING_MODE)
	EndMethod
	
	Method setCellText(rowIndex:Int, columnIndex:Int, text:String)
		IrrGUI_IGUITable_setCellText(handle, rowIndex, columnIndex, StringToWChar(text))
	EndMethod
	
	Method setCellTextAndColor(rowIndex:Int, columnIndex:Int, text:String, color:SColor)
		IrrGUI_IGUITable_setCellTextAndColor(handle, rowIndex, columnIndex, StringToWChar(text), color.handle)
	EndMethod
	
	Method setCellData(rowIndex:Int, columnIndex:Int, data:Byte Ptr)
		IrrGUI_IGUITable_setCellData(handle, rowIndex, columnIndex, data)
	EndMethod
	
	Method setCellColor(rowIndex:Int, columnIndex:Int, color:SColor)
		IrrGUI_IGUITable_setCellColor(handle, rowIndex, columnIndex, color.handle)
	EndMethod
	
	Method getCellText:String(rowIndex:Int, columnIndex:Int)
		Return WCharToString(IrrGUI_IGUITable_getCellText(handle, rowIndex, columnIndex))
	EndMethod
	
	Method getCellData:Byte Ptr(rowIndex:Int, columnIndex:Int)
		Return IrrGUI_IGUITable_getCellData(handle, rowIndex, columnIndex)
	EndMethod
	
	Method clear()
		IrrGUI_IGUITable_clear(handle)
	EndMethod

	Method setDrawFlags(flags:Int)
		IrrGUI_IGUITable_setDrawFlags(handle, flags)
	EndMethod
	
	Method getDrawFlags:Int()
		Return IrrGUI_IGUITable_getDrawFlags(handle)
	EndMethod

EndType


