Public

' ----------------------------------------------------------------
' IFileArchive
' ----------------------------------------------------------------

Type IFileArchive Extends IReferenceCounted

	Method createAndOpenFile:IReadFile(filename:String)
		Return IReadFile.createFromHandle(IrrIO_IFileArchive_createAndOpenFile(handle, filename), True)
	EndMethod
	
	Method createAndOpenFileByIndex:IReadFile(index:Int)
		Return IReadFile.createFromHandle(IrrIO_IFileArchive_createAndOpenFileByIndex(handle, index), True)
	EndMethod
	
	Method getFileList:IFileList()
		Return IFileList.createFromHandle(IrrIO_IFileArchive_getFileList(handle), False)
	EndMethod
	
	Method getType:Int()
		Return IrrIO_IFileArchive_getType(handle)
	EndMethod

	Function createFromHandle:IFileArchive(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:IFileArchive = New IFileArchive
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

 	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrIO_IFileArchive_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrIO_IFileArchive_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrIO_IFileArchive_grab(handle)
	EndMethod

	Method Delete()
		If (mustdelete) Then drop()
	EndMethod	
EndType


' ----------------------------------------------------------------
' IArchiveLoader
' ----------------------------------------------------------------

Type IArchiveLoader Extends IReferenceCounted

	Method isALoadableFileFormat:Int(filename:String)
		Return IrrIO_IArchiveLoader_isALoadableFileFormat(handle, filename)
	EndMethod
	
	Method isALoadableFileFormatFromIO:Int(file:IReadFile)
		Return IrrIO_IArchiveLoader_isALoadableFileFormatFromIO(handle, _HANDLE(file))
	EndMethod
	
	Method isALoadableFileFormatFromType:Int(E_FILE_ARCHIVE_TYPE:Int)
		Return IrrIO_IArchiveLoader_isALoadableFileFormatFromType(handle, E_FILE_ARCHIVE_TYPE) 
	EndMethod
	
	Method createArchive:IFileArchive(filename:String, bIgnoreCase:Int, bIgnorePaths:Int)
		Return IFileArchive.createFromHandle(IrrIO_IArchiveLoader_createArchive(handle, filename, bIgnoreCase, bIgnorePaths), True)
	EndMethod
	
	Method createArchiveFromIO:IFileArchive(file:IReadFile, bIgnoreCase:Int, bIgnorePaths:Int)
		Return IFileArchive.createFromHandle(IrrIO_IArchiveLoader_createArchiveFromIO(handle, _HANDLE(file), bIgnoreCase, bIgnorePaths), True)
	EndMethod
	
	Function createFromHandle:IArchiveLoader(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:IArchiveLoader = New IArchiveLoader
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

 	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrIO_IArchiveLoader_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrIO_IArchiveLoader_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrIO_IArchiveLoader_grab(handle)
	EndMethod

	Method Delete()
		If (mustdelete) Then drop()
	EndMethod	
EndType
