' ------------------------------------------------------------------------------------
' irr::IOSOperator wrappers
' ------------------------------------------------------------------------------------
Public

Type IOSOperator Extends IReferenceCounted Final

	Function createFromHandle:IOSOperator(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:IOSOperator=New IOSOperator
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return Irr_IOSOperator_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return Irr_IOSOperator_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		Irr_IOSOperator_grab(handle)
	EndMethod

	Method Delete()
		If (mustdelete) Then drop()
	EndMethod

	Method copyToClipboard(text:String)
		Irr_IOSOperator_copyToClipboard(handle,text)
	EndMethod
	
	Method getOperationSystemVersion:String()
		Return Irr_IOSOperator_getOperationSystemVersion(handle)
	EndMethod
	
	Method getTextFromClipboard:String()
		Return Irr_IOSOperator_getTextFromClipboard(handle)
	EndMethod

	Method getProcessorSpeedMHz:Int(MHz:Int Var)
		Return Irr_IOSOperator_getProcessorSpeedMHz(handle,Varptr(MHz))
	EndMethod
	
	Method getSystemMemory:Int(Total:Int Var,Avail:Int Var)
		Return Irr_IOSOperator_getSystemMemory(handle,Varptr(Total),Varptr(Avail))
	EndMethod

EndType


