' ------------------------------------------------------------------------------------
'  irr::scene::IMeshCache wrappers
' ------------------------------------------------------------------------------------
Public

Type IMeshCache Extends IReferenceCounted

	Function createFromHandle:IMeshCache(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:IMeshCache=New IMeshCache
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method addMesh(filename:String, mesh:IAnimatedMesh)
		IrrScene_IMeshCache_addMesh(handle,filename,mesh.handle)
	EndMethod
	
	Method removeAnimatedMesh(mesh:IAnimatedMesh)
		IrrScene_IMeshCache_removeAnimatedMesh(handle,mesh.handle)
	EndMethod

	Method removeMesh(mesh:IMesh)
		IrrScene_IMeshCache_removeMesh(handle,mesh.handle)
	EndMethod
	
	Method getMeshCount:Int()
		Return IrrScene_IMeshCache_getMeshCount(handle)
	EndMethod
	
	Method getAnimatedMeshIndex:Int(mesh:IAnimatedMesh)
		Return IrrScene_IMeshCache_getAnimatedMeshIndex:Int(handle,mesh.handle)
	EndMethod

	Method getMeshIndex:Int(mesh:IMesh)
		Return IrrScene_IMeshCache_getMeshIndex:Int(handle,mesh.handle)
	EndMethod
	
	' do not delete
	Method getMeshByIndex:IAnimatedMesh(index:Int)
		Return IAnimatedMesh.createFromHandle(IrrScene_IMeshCache_getMeshByIndex(handle,index),False)
	EndMethod

	Method getMeshFilenameByIdx:String(index:Int)
		Return String.FromCString(IrrScene_IMeshCache_getMeshFilenameByIdx(handle,index))
	EndMethod
	
	Method getAnimatedMeshFilename:String(mesh:IAnimatedMesh)
		Return String.FromCString(IrrScene_IMeshCache_getAnimatedMeshFilename(handle,mesh.handle))
	EndMethod
	
	Method getMeshFilename:String(mesh:IMesh)
		Return String.FromCString(IrrScene_IMeshCache_getMeshFilename(handle,mesh.handle))
	EndMethod

	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrScene_IMeshCache_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrScene_IMeshCache_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrScene_IMeshCache_grab(handle)
	EndMethod
	
	Method Delete()
		If (mustdelete) Then drop()
	EndMethod	
	
	Method getMeshByFilename:IAnimatedMesh(filename:String)
		Return IAnimatedMesh.createFromHandle(IrrScene_IMeshCache_getMeshByFilename(handle,filename),False)
	EndMethod

	Method setMeshFilenameByIndex:Int(index:Int,filename:String)
		Return IrrScene_IMeshCache_setMeshFilenameByIndex(handle,index,filename)
	EndMethod
	
	Method setAnimatedMeshFilename:Int(mesh:IAnimatedMesh,filename:String)
		Return IrrScene_IMeshCache_setAnimatedMeshFilename(handle,mesh.handle,filename)
	EndMethod
	
	Method setMeshFilename:Int(mesh:IMesh,filename:String)
		Return IrrScene_IMeshCache_setMeshFilename(handle,mesh.handle,filename)
	EndMethod

	Method isMeshLoaded:Int(filename:String)
		Return IrrScene_IMeshCache_isMeshLoaded(handle,filename)	
	EndMethod
	
	Method clear()
		IrrScene_IMeshCache_clear(handle)
	EndMethod
	
	Method clearUnusedMeshes()
		IrrScene_IMeshCache_clearUnusedMeshes(handle)
	EndMethod

EndType


