//------------------------------------------------------------------------------------
// irr::scene::IMeshCache wrappers
//------------------------------------------------------------------------------------

extern "C"
{

	void IrrScene_IMeshCache_addMesh(IMeshCache* imc, const c8* filename, IAnimatedMesh* mesh)
	{
		if (imc)
			imc->addMesh(path(filename),mesh);
	}

	void IrrScene_IMeshCache_removeAnimatedMesh(IMeshCache* imc,IAnimatedMesh* mesh)
	{
		if (imc)
			imc->removeMesh(mesh);
	}

	void IrrScene_IMeshCache_removeMesh(IMeshCache* imc,IMesh* mesh)
	{
		if (imc)
			imc->removeMesh(mesh);
	}

	u32 IrrScene_IMeshCache_getMeshCount(IMeshCache* imc)
	{
		if (imc)
			return imc->getMeshCount();
		else return 0;
	}

	s32 IrrScene_IMeshCache_getAnimatedMeshIndex(IMeshCache* imc,IAnimatedMesh* mesh)
	{
		if (imc)
			return imc->getMeshIndex(mesh);
		else return 0;
	}

	s32 IrrScene_IMeshCache_getMeshIndex(IMeshCache* imc,IMesh* mesh)
	{
		if (imc)
			return imc->getMeshIndex(mesh);
		else return 0;
	}

	IAnimatedMesh* IrrScene_IMeshCache_getMeshByIndex(IMeshCache* imc,u32 index)
	{
		if (imc)
			return imc->getMeshByIndex(index);
		else return 0;
	}

	const c8* IrrScene_IMeshCache_getMeshFilenameByIdx(IMeshCache* imc,u32 index)
	{
		if (imc)
			return imc->getMeshFilename(index).c_str();
		else return 0;
	}

	const c8* IrrScene_IMeshCache_getAnimatedMeshFilename(IMeshCache* imc,IAnimatedMesh* mesh)
	{
		if (imc)
			return imc->getMeshFilename(mesh).c_str();
		else return 0;
	}

	const c8* IrrScene_IMeshCache_getMeshFilename(IMeshCache* imc,IMesh* mesh)
	{
		if (imc)
			return imc->getMeshFilename(mesh).c_str();
		else return 0;
	}
	
	bool IrrScene_IMeshCache_drop(IMeshCache* unk)
	{
		if (unk)
			return unk->drop();
		else return 0;
	}
	
	const c8* IrrScene_IMeshCache_getDebugName(IMeshCache* unk)
	{
		if (unk)
			return unk->getDebugName();
		else return "";
	}
	
	void IrrScene_IMeshCache_grab(IMeshCache* unk)
	{
		if (unk)
			unk->grab();
	}
	
	// do not delete
	IAnimatedMesh* IrrScene_IMeshCache_getMeshByFilename(IMeshCache* imc, const c8* filename)
	{
		if (imc)
			return imc->getMeshByFilename(path(filename));
		else return 0;
	}

	bool IrrScene_IMeshCache_setMeshFilenameByIndex(IMeshCache* imc,u32 index, const c8* filename)
	{
		if (imc)
			return imc->setMeshFilename(index,path(filename));
		else return false;
	}
	
	bool IrrScene_IMeshCache_setAnimatedMeshFilename(IMeshCache* imc,const IAnimatedMesh* const mesh, const c8* filename)
	{
		if (imc)
			return imc->setMeshFilename(mesh,path(filename));
		else return false;
	}

	bool IrrScene_IMeshCache_setMeshFilename(IMeshCache* imc,const IMesh* const mesh, const c8* filename)
	{
		if (imc)
			return imc->setMeshFilename(mesh,path(filename));
		else return false;
	}

	bool IrrScene_IMeshCache_isMeshLoaded(IMeshCache* imc,const c8* filename)
	{
		if (imc)
			return imc->isMeshLoaded(path(filename));
		else return false;
	}
	
	void IrrScene_IMeshCache_clear(IMeshCache* imc)
	{
		if (imc)
			imc->clear();
	}

	void IrrScene_IMeshCache_clearUnusedMeshes(IMeshCache* imc)
	{
		if (imc)
			imc->clearUnusedMeshes();
	}

}

