//------------------------------------------------------------------------------------
// irr::video::IGPUProgrammingServices wrappers
//
// WARNING: this cannot be created manually.  it can be obtained by calling
// IVideoDriver::getGPUProgrammingServices()
//------------------------------------------------------------------------------------

extern "C" {

s32 IrrVideo_IGPUProgrammingServices_addHighLevelShaderMaterial(
	IGPUProgrammingServices* gpusrv,
	const c8 *vertexShaderProgram, 
	const c8 *vertexShaderEntryPointName=0,
	E_VERTEX_SHADER_TYPE vsCompileTarget=EVST_VS_1_1, 
	const c8 *pixelShaderProgram=0,
	const c8 *pixelShaderEntryPointName=0, 
	E_PIXEL_SHADER_TYPE psCompileTarget=EPST_PS_1_1,
	IShaderConstantSetCallBack *callback=0, 
	E_MATERIAL_TYPE baseMaterial=video::EMT_SOLID,
	s32 userData=0)
{

	if (!vertexShaderEntryPointName) vertexShaderEntryPointName="main";
	if (!pixelShaderEntryPointName) pixelShaderEntryPointName="main";

	if (gpusrv)
		return gpusrv->addHighLevelShaderMaterial(
			vertexShaderProgram,
			vertexShaderEntryPointName,
			vsCompileTarget,
			pixelShaderProgram,
			pixelShaderEntryPointName, 
			psCompileTarget,
			callback,
			baseMaterial,
			userData);
	else return -1;
}

s32 IrrVideo_IGPUProgrammingServices_addHighLevelShaderMaterialFromFileStream(
	IGPUProgrammingServices* gpusrv,
	io::IReadFile *vertexShaderProgram,
	const c8 *vertexShaderEntryPointName=0,
	E_VERTEX_SHADER_TYPE vsCompileTarget=EVST_VS_1_1,
	io::IReadFile *pixelShaderProgram=0,
	const c8 *pixelShaderEntryPointName=0,
	E_PIXEL_SHADER_TYPE psCompileTarget=EPST_PS_1_1,
	IShaderConstantSetCallBack *callback=0,
	E_MATERIAL_TYPE baseMaterial=video::EMT_SOLID,
	s32 userData=0)
{
	if (!vertexShaderEntryPointName) vertexShaderEntryPointName="main";
	if (!pixelShaderEntryPointName) pixelShaderEntryPointName="main";

	if (gpusrv)
		return gpusrv->addHighLevelShaderMaterialFromFiles(
			vertexShaderProgram,
			vertexShaderEntryPointName,
			vsCompileTarget,
			pixelShaderProgram,
			pixelShaderEntryPointName,
			psCompileTarget,
			callback,
			baseMaterial,
			userData);
	else return -1;
}

s32 IrrVideo_IGPUProgrammingServices_addHighLevelShaderMaterialFromFiles(
	IGPUProgrammingServices* gpusrv,
	const c8 *vertexShaderProgramFileName,
	const c8 *vertexShaderEntryPointName=0,
	E_VERTEX_SHADER_TYPE vsCompileTarget=EVST_VS_1_1,
	const c8 *pixelShaderProgramFileName=0,
	const c8 *pixelShaderEntryPointName=0,
	E_PIXEL_SHADER_TYPE psCompileTarget=EPST_PS_1_1,
	IShaderConstantSetCallBack *callback=0,
	E_MATERIAL_TYPE baseMaterial=video::EMT_SOLID,
	s32 userData=0)
{
	if (!vertexShaderEntryPointName) vertexShaderEntryPointName="main";
	if (!pixelShaderEntryPointName) pixelShaderEntryPointName="main";

	if (gpusrv)
		return gpusrv->addHighLevelShaderMaterialFromFiles(
			path(vertexShaderProgramFileName),
			vertexShaderEntryPointName,
			vsCompileTarget,
			path(pixelShaderProgramFileName),
			pixelShaderEntryPointName,
			psCompileTarget,
			callback,
			baseMaterial,
			userData);
	else return -1;
}

s32 IrrVideo_IGPUProgrammingServices_addShaderMaterial(
	IGPUProgrammingServices* gpusrv,
	const c8 *vertexShaderProgram=0,
	const c8 *pixelShaderProgram=0,
	IShaderConstantSetCallBack *callback=0,
	E_MATERIAL_TYPE baseMaterial=video::EMT_SOLID,
	s32 userData=0)
{
	if (gpusrv)
		return gpusrv->addShaderMaterial(
			vertexShaderProgram,
			pixelShaderProgram,
			callback,
			baseMaterial,
			userData);
	else return -1;
}

s32 IrrVideo_IGPUProgrammingServices_addShaderMaterialFromFiles(
	IGPUProgrammingServices* gpusrv,
	const c8 *vertexShaderProgramFileName,
	const c8 *pixelShaderProgramFileName,
	IShaderConstantSetCallBack *callback=0,
	E_MATERIAL_TYPE baseMaterial=video::EMT_SOLID,
	s32 userData=0)
{
	if (gpusrv)
		return gpusrv->addShaderMaterialFromFiles(
			path(vertexShaderProgramFileName),
			path(pixelShaderProgramFileName),
			callback,
			baseMaterial,
			userData);
	else return -1;
}

s32 IrrVideo_IGPUProgrammingServices_addShaderMaterialFromFileStream(
	IGPUProgrammingServices* gpusrv,
	io::IReadFile *vertexShaderProgram,
	io::IReadFile *pixelShaderProgram,
	IShaderConstantSetCallBack *callback=0,
	E_MATERIAL_TYPE baseMaterial=video::EMT_SOLID,
	s32 userData=0)
{
	if (gpusrv)
		return gpusrv->addShaderMaterialFromFiles(
			vertexShaderProgram,
			pixelShaderProgram,
			callback,
			baseMaterial,
			userData);
	else return -1;
}

} // extern "C"

