' ------------------------------------------------------------------------------------
' irr::video::IMaterialRendererServices wrappers
' ------------------------------------------------------------------------------------

Public

Type IMaterialRendererServices Extends IrrBase Final

	Function createFromHandle:IMaterialRendererServices(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:IMaterialRendererServices=New IMaterialRendererServices
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	' do not delete
	Method getVideoDriver:IVideoDriver()
		Return IVideoDriver.createFromHandle(IrrVideo_IMaterialRendererServices_getVideoDriver(handle),False)
	EndMethod
	Method setBasicRenderStates(material:SMaterial,lastMaterial:SMaterial,bResetAllRenderstates:Int)
		IrrVideo_IMaterialRendererServices_setBasicRenderStates(handle,material.handle,lastMaterial.handle,bResetAllRenderstates)
	EndMethod
	Method setPixelShaderConstant(data:Float Ptr,startRegister:Int,constantAmount:Int=1)
		IrrVideo_IMaterialRendererServices_setPixelShaderConstant(handle,data,startRegister,constantAmount)
	EndMethod
	Method setPixelShaderConstantFromName:Int(name:String,floats:Float Ptr,count:Int)
		Return IrrVideo_IMaterialRendererServices_setPixelShaderConstantFromName(handle,name,floats,count)
	EndMethod
	Method setVertexShaderConstant(data:Float Ptr,startRegister:Int,constantAmount:Int=1)
		IrrVideo_IMaterialRendererServices_setVertexShaderConstant(handle,data,startRegister,constantAmount)
	EndMethod
	Method setVertexShaderConstantFromName:Int(name:String,floats:Float Ptr,count:Int)
		Return IrrVideo_IMaterialRendererServices_setVertexShaderConstantFromName(handle,name,floats,count)
	EndMethod
	
EndType
