' ------------------------------------------------------------------------------------
' irr::video::IVideoDriver wrappers
' ------------------------------------------------------------------------------------
Public 

' enum E_RENDER_TARGET
Const ERT_FRAME_BUFFER:Int = 0
Const ERT_STEREO_LEFT_BUFFER:Int = 1
Const ERT_RENDER_TEXTURE:Int = 2
Const ERT_STEREO_RIGHT_BUFFER:Int = 3
Const ERT_STEREO_BOTH_BUFFERS:Int = 4
Const ERT_AUX_BUFFER0:Int = 5
Const ERT_AUX_BUFFER1:Int = 6
Const ERT_AUX_BUFFER2:Int = 7
Const ERT_AUX_BUFFER3:Int = 8
Const ERT_AUX_BUFFER4:Int = 9

' enum E_FOG_TYPE
Const EFT_FOG_EXP:Int = 0
Const EFT_FOG_LINEAR:Int = 1
Const EFT_FOG_EXP2:Int = 2

' enum E_LOST_RESSOURCE
Const ELR_DEVICE:Int = 1
Const ELR_TEXTURES:Int = 2
Const ELR_RTTS:Int = 4
Const ELR_HW_BUFFERS:Int = 8

' enum E_TRANSFORMATION_STATE
Const ETS_VIEW:Int = 0
Const ETS_WORLD:Int = 1
Const ETS_PROJECTION:Int = 2
Const ETS_TEXTURE_0:Int = 3
Const ETS_TEXTURE_1:Int = 4
Const ETS_TEXTURE_2:Int = 5
Const ETS_TEXTURE_3:Int = 6
Const ETS_TEXTURE_4:Int = 7
Const ETS_TEXTURE_5:Int = 8
Const ETS_TEXTURE_6:Int = 9
Const ETS_TEXTURE_7:Int = 10
Const ETS_COUNT:Int = 11
		
Extern 

	Function IrrVideo_IVideoDriver_beginScene:Int(pIVideoDriver:Int,bBackBuffer:Int,bZBuffer:Int,pSColor:Int=0, windowId:Byte Ptr = Null, pRect_sourceRect:Int = 0)
	Function IrrVideo_IVideoDriver_endScene:Int(pIVideoDriver:Int)
	Function IrrVideo_IVideoDriver_queryFeature:Int(pIVideoDriver:Int,E_VIDEO_DRIVER_FEATURE:Int)
	Function IrrVideo_IVideoDriver_setTransform(pIVideoDriver:Int,E_TRANSFORMATION_STATE:Int,pMatrix4:Int)
	Function IrrVideo_IVideoDriver_getTransform:Int(pIVideoDriver:Int,E_TRANSFORMATION_STATE:Int)  ' returns matrix4*
	Function IrrVideo_IVideoDriver_setMaterial(pIVideoDriver:Int,pSMaterial:Int)
	Function IrrVideo_IVideoDriver_getTexture:Int(pIVideoDriver:Int,filename$z)  ' returns ITexture*
	Function IrrVideo_IVideoDriver_getTextureFromStream:Int(pIVideoDriver:Int,pIReadFile:Int) ' returns ITexture* 
	Function IrrVideo_IVideoDriver_addTexture(pIVideoDriver:Int,pDimension2di:Int,name$z,ECOLOR_FORMAT:Int=ECF_A8R8G8B8) ' returns ITexture*
	Function IrrVideo_IVideoDriver_addTextureFromImage(pIVideoDriver:Int,name$z,pIImage:Int) ' returns ITexture*
	Function IrrVideo_IVideoDriver_removeTexture(pIVideoDriver:Int,pITexture:Int)
	Function IrrVideo_IVideoDriver_removeAllTextures(pIVideoDriver:Int)
	Function IrrVideo_IVideoDriver_makeColorKeyTexture(pIVideoDriver:Int,pITexture:Int,pSColor:Int, zeroTexels:Int = False)
	Function IrrVideo_IVideoDriver_makeColorKeyTextureFromPixel(pIVideoDriver:Int,pITexture:Int,pPosition2di:Int, zeroTexels:Int = False)
	Function IrrVideo_IVideoDriver_makeNormalMapTexture(pIVideoDriver:Int,pITexture:Int,amplitude:Float=1.0)
	Function IrrVideo_IVideoDriver_setRenderTarget(pIVideoDriver:Int,pITexture:Int,bClearBackBuffer:Int=True,bClearZBuffer:Int=True,pSColor_color:Int=0)
	Function IrrVideo_IVideoDriver_setRenderTargetByEnum(pIVideoDriver:Int,E_RENDER_TARGET:Int,bClearBackBuffer:Int=True,bClearZBuffer:Int=True,pSColor_color:Int=0)
	Function IrrVideo_IVideoDriver_setViewPort(pIVideoDriver:Int,pRecti_area:Int)
	Function IrrVideo_IVideoDriver_getViewPort(pIVideoDriver:Int) ' returns rect<s32>* 
	Function IrrVideo_IVideoDriver_drawVertexPrimitiveList(pIVideoDriver:Int, vertices:Byte Ptr, vertexCount:Int, indexList:Byte Ptr, primCount:Int, E_VERTEX_TYPE:Int = EVT_STANDARD, E_PRIMITIVE_TYPE:Int = EPT_TRIANGLES, E_INDEX_TYPE:Int = EIT_16BIT)
	Function IrrVideo_IVideoDriver_draw2DVertexPrimitiveList(pIVideoDriver:Int, vertices:Byte Ptr, vertexCount:Int, indexList:Byte Ptr, primCount:Int, E_VERTEX_TYPE:Int = EVT_STANDARD, E_PRIMITIVE_TYPE:Int = EPT_TRIANGLES, E_INDEX_TYPE:Int = EIT_16BIT)
	Function IrrVideo_IVideoDriver_draw3DLine(pIVideoDriver:Int,pvector3df_start:Int,pvector3df_end:Int,pSColor:Int=0) ' def color=255,255,255,255
	Function IrrVideo_IVideoDriver_draw3DTriangle(pIVideoDriver:Int,ptriangle3df:Int,pSColor:Int=0) ' def color=255,255,255,255
	Function IrrVideo_IVideoDriver_draw3DBox(pIVideoDriver:Int,paabbox3df:Int,pSColor:Int=0) ' def color=255,255,255,255
	Function IrrVideo_IVideoDriver_draw2DImage(pIVideoDriver:Int,pITexture:Int,pPosition2di_destPos:Int)
	Function IrrVideo_IVideoDriver_draw2DImageSegment(pIVideoDriver:Int,pITexture:Int,pPosition2di_destPos:Int,pRecti_sourceRect:Int,pRecti_clipRect:Int=0,pSColor:Int=0,bUseAlphaChannelOfTexture:Int=False)
	Function IrrVideo_IVideoDriver_draw2DImageSegmentToRect(pIVideoDriver:Int,pITexture:Int,pRecti_destRect:Int,pRecti_sourceRect:Int,pRecti_clipRect:Int=0,colorArray:Int Ptr=Null,colorArraySize:Int=0,bUseAlphaChannelOfTexture:Int=False)
	Function IrrVideo_IVideoDriver_draw2DRectangle(pIVideoDriver:Int,pSColor:Int,pRecti_pos:Int,pRecti_clip:Int=0)
	Function IrrVideo_IVideoDriver_draw2DRectangleWithGradient(pIVideoDriver:Int,pRecti_pos:Int,pSColorLeftUp:Int,pSColorRightUp:Int,pSColorLeftDown:Int,pSColorRightDown:Int,pRecti_clip:Int=0)
	Function IrrVideo_IVideoDriver_draw2DRectangleOutline(pIVideoDriver:Int, pRecti_pos:Int, pSColor:Int = 0)
	Function IrrVideo_IVideoDriver_draw2DLine(pIVideoDriver:Int,pPosition2di_start:Int,pPosition2di_end:Int,pSColor:Int=0) ' def color=255,255,255,255
	Function IrrVideo_IVideoDriver_draw2DPolygon(pIVideoDriver:Int,pPosition2di_center:Int,radius:Float,pSColor:Int=0,vertexCount:Int=10)  ' def color=100,255,255,255
	Function IrrVideo_IVideoDriver_drawStencilShadowVolume(pIVideoDriver:Int,pvector3df_triangles_arr:Int,count:Int,bZfail:Int=True)
	Function IrrVideo_IVideoDriver_drawStencilShadow(pIVideoDriver:Int,bClearStencilBuffer:Int=False,pSColor_leftUpEdge:Int=0,pSColor_rightUpEdge:Int=0,pSColor_leftDownEdge:Int=0,pSColor_rightDownEdge:Int=0) ' colors default to 255,0,0,0
	Function IrrVideo_IVideoDriver_drawMeshBuffer(pIVideoDriver:Int,pIMeshBuffer:Int)
	Function IrrVideo_IVideoDriver_setFog(pIVideoDriver:Int,pSColor:Int=0, E_FOG_TYPE:Int = EFT_FOG_LINEAR, start:Float=50.0,fend:Float=100.0,density:Float=0.01,bPixelFog:Int=False,bRangeFog:Int=False) ' color defaults to 0,255,255,255
	Function IrrVideo_IVideoDriver_getScreenSize:Int(pIVideoDriver:Int) ' returns dimension2d<s32>*
	Function IrrVideo_IVideoDriver_getCurrentRenderTargetSize:Int(pIVideoDriver:Int) ' returns dimension2d<s32>* 
	Function IrrVideo_IVideoDriver_getFPS:Int(pIVideoDriver:Int)
	Function IrrVideo_IVideoDriver_getPrimitiveCountDrawn:Int(pIVideoDriver:Int,param:Int=0) ' returns unsigned 32
	Function IrrVideo_IVideoDriver_deleteAllDynamicLights(pIVideoDriver:Int)
	Function IrrVideo_IVideoDriver_addDynamicLight(pIVideoDriver:Int,pSLight:Int)
	Function IrrVideo_IVideoDriver_setAmbientLight(pIVideoDriver:Int,pSColorf:Int)
	Function IrrVideo_IVideoDriver_getMaximalDynamicLightAmount:Int(pIVideoDriver:Int)
	Function IrrVideo_IVideoDriver_getDynamicLightCount:Int(pIVideoDriver:Int)
	Function IrrVideo_IVideoDriver_getDynamicLight:Int(pIVideoDriver:Int,idx:Int) ' returns SLight* 
	Function IrrVideo_IVideoDriver_getName$z(pIVideoDriver:Int) ' returns Const c8*
	Function IrrVideo_IVideoDriver_getMaximalPrimitiveCount:Int(pIVideoDriver:Int)
	Function IrrVideo_IVideoDriver_setTextureCreationFlag(pIVideoDriver:Int,E_TEXTURE_CREATION_FLAG:Int,bEnabled:Int = True)
	Function IrrVideo_IVideoDriver_getTextureCreationFlag:Int(pIVideoDriver:Int,E_TEXTURE_CREATION_FLAG:Int)
	Function IrrVideo_IVideoDriver_createImageFromFile:Int(pIVideoDriver:Int,filename$z) ' returns IImage*
	Function IrrVideo_IVideoDriver_createImageFromStream:Int(pIVideoDriver:Int,pIReadFile:Int) ' returns IImage*
	Function IrrVideo_IVideoDriver_createImageFromData:Int(pIVideoDriver:Int,ECOLOR_FORMAT:Int,pDimension2di_size:Int,pdata:Byte Ptr,ownForeignMemory:Int=False,deleteMemory:Int=True) ' returns IImage*
	Function IrrVideo_IVideoDriver_getMaterialRendererCount:Int(pIVideoDriver:Int)
	' dont Delete reference
	Function IrrVideo_IVideoDriver_getMaterialRenderer:Int(pIVideoDriver:Int,idx:Int) ' returns IMaterialRenderer* 
	Function IrrVideo_IVideoDriver_getExposedVideoData:Int(pIVideoDriver:Int) ' returns SExposedVideoData* 
	Function IrrVideo_IVideoDriver_getDriverType:Int(pIVideoDriver:Int) ' returns E_DRIVER_TYPE	
	Function IrrVideo_IVideoDriver_drawIndexedTriangleList(pIVideoDriver:Int,parray_S3DVertex_vertices:Int,parray_u16_indexList:Int)
	Function IrrVideo_IVideoDriver_drawIndexedTriangleListFromCoords(pIVideoDriver:Int,parray_S3DVertex2TCoords_vertices:Int,parray_u16_indexList:Int)
	Function IrrVideo_IVideoDriver_drawIndexedTriangleListTangents(pIVideoDriver:Int,parray_S3DVertexTangents_vertices:Int,parray_u16_indexList:Int)
	Function IrrVideo_IVideoDriver_drawIndexedTriangleFan(pIVideoDriver:Int,parray_S3DVertex_vertices:Int,parray_u16_indexList:Int)
	Function IrrVideo_IVideoDriver_drawIndexedTriangleFanFromCoords(pIVideoDriver:Int,parray_S3DVertex2TCoords_vertices:Int,parray_u16_indexList:Int)

	' do Not Delete Ptr
	Function IrrVideo_IVideoDriver_getGPUProgrammingServices:Int(pIVideoDriver_driver:Int) ' returns IGPUProgrammingServices*
	Function IrrVideo_IVideoDriver_clearZBuffer(pIVideoDriver:Int)

	Function IrrVideo_IVideoDriver_getMeshManipulator:Int(IVideoDriver:Int) ' return IMeshManipulator*
	
	Function IrrVideo_IVideoDriver_getTextureByIndex:Int(pIVideoDriver:Int,index:Int) ' returns ITexture*
	Function IrrVideo_IVideoDriver_getTextureCount:Int(pIVideoDriver:Int)
	Function IrrVideo_IVideoDriver_addMaterialRenderer:Int(pIVideoDriver:Int,pIMaterialRenderer:Int,name$z=Null)
	Function IrrVideo_IVideoDriver_addExternalImageLoader(pIVideoDriver:Int,pIImageLoader:Int)
	Function IrrVideo_IVideoDriver_addExternalImageWriter(pIVideoDriver:Int,pIImageWriter:Int)
	Function IrrVideo_IVideoDriver_writeImageToFile:Int(pIVideoDriver:Int,pIImage:Int,filename$z,param:Int=0)
	Function IrrVideo_IVideoDriver_getMaterialRendererName$z(pIVideoDriver:Int,idx:Int)
	Function IrrVideo_IVideoDriver_setMaterialRendererName(pIVideoDriver:Int,idx:Int,name$z)
	Function IrrVideo_IVideoDriver_createAttributesFromMaterial:Int(pIVideoDriver:Int,pSMaterial:Int) ' returns io::IAttributes*
	Function IrrVideo_IVideoDriver_fillMaterialStructureFromAttributes(pIVideoDriver:Int,pSMaterial_out:Int,pIAttributes:Int)
	Function IrrVideo_IVideoDriver_createScreenShot:Int(pIVideoDriver:Int) ' returns IImage*
	
	Function IrrVideo_IVideoDriver_drop:Int(pIUnknown:Int)
	Function IrrVideo_IVideoDriver_getDebugName$z(pIUnknown:Int)
	Function IrrVideo_IVideoDriver_grab(pIUnknown:Int)
	
	Function IrrVideo_IVideoDriver_renameTexture(pIVideoDriver:Int,pITexture:Int,newName$z)
	' do not delete
	Function IrrVideo_IVideoDriver_findTexture:Int(pIVideoDriver:Int, filename$z) ' returns ITexture*
	Function IrrVideo_IVideoDriver_setClipPlane:Int(pIVideoDriver:Int, index:Int, pPlane3df:Int, bEnable:Int = False)
	Function IrrVideo_IVideoDriver_enableClipPlane(pIVideoDriver:Int, index:Int, bEnable:Int)

	' must delete
	Function IrrVideo_IVideoDriver_createImageEmpty:Int(pIVideoDriver:Int, ECOLOR_FORMAT:Int, pDimension2di_size:Int) ' returns IImage*
	' must delete
	Function IrrVideo_IVideoDriver_createImageFromImage:Int(pIVideoDriver:Int, ECOLOR_FORMAT:Int, pIImage:Int) ' returns IImage*
	' must delete
	Function IrrVideo_IVideoDriver_createImageFromImagePart:Int(pIVideoDriver:Int, pIImage:Int, pPosition2di_pos:Int, pDimension2di_size:Int) ' returns IImage*

	Function IrrVideo_IVideoDriver_OnResize(pIVideoDriver:Int, pDimension2di_size:Int)

	Function IrrVideo_IVideoDriver_setAllowZWriteOnTransparent(pIVideoDriver:Int, bFlag:Int)
	Function IrrVideo_IVideoDriver_disableFeature(pIVideoDriver:Int, E_VIDEO_DRIVER_FEATURE:Int, bFlag:Int = True)
	Function IrrVideo_IVideoDriver_checkDriverReset:Int(pIVideoDriver:Int)
	' do not delete
	Function IrrVideo_IVideoDriver_addRenderTargetTexture:Int(pIVideoDriver:Int, pDimension2di_size:Int, name$z = Null, ECOLOR_FORMAT:Int = ECF_UNKNOWN) ' returns ITexture*
	Function IrrVideo_IVideoDriver_removeHardwareBuffer(pIVideoDriver:Int, pIMeshBuffer:Int)
	Function IrrVideo_IVideoDriver_removeAllHardwareBuffers(pIVideoDriver:Int)
	Function IrrVideo_IVideoDriver_drawPixel(pIVideoDriver:Int, x:Int, y:Int, pSColor:Int)
	Function IrrVideo_IVideoDriver_getColorFormat:Int(pIVideoDriver:Int) ' returns ECOLOR_FORMAT
	Function IrrVideo_IVideoDriver_getVendorInfo$z(pIVideoDriver:Int) 

	' do not delete
	Function IrrVideo_IVideoDriver_getOverrideMaterial:Int(pIVideoDriver:Int) ' returns SOverrideMaterial*
	Function IrrVideo_IVideoDriver_setMinHardwareBufferVertexCount(pIVideoDriver:Int, count:Int)
	Function IrrVideo_IVideoDriver_createImageFromTexturePart:Int(pIVideoDriver:Int, pITexture:Int, pPosition2di_pos:Int, pDimension2di_size:Int) ' returns IImage* 
	Function IrrVideo_IVideoDriver_writeImageToFileIO:Int(pIVideoDriver:Int, pIImage:Int, pIWriteFile:Int, param:Int = 0)
	Function IrrVideo_IVideoDriver_turnLightOn(pIVideoDriver:Int, lightIndex:Int, bTurnOn:Int)

	Function IrrVideo_IVideoDriver_getImageLoaderCount:Int(pIVideoDriver:Int)
	' do not delete
	Function IrrVideo_IVideoDriver_getImageLoader:Int(pIVideoDriver:Int, n:Int) ' returns IImageLoader* 
	Function IrrVideo_IVideoDriver_getImageWriterCount:Int(pIVideoDriver:Int)
	' do not delete
	Function IrrVideo_IVideoDriver_getImageWriter:Int(pIVideoDriver:Int, n:Int) ' returns IImageWriter*

	Function IrrVideo_IVideoDriver_draw2DImageBatch(pIVideoDriver:Int, pITexture:Int, pPosition2di_pos:Int, sourceRects_array:Int Ptr, sourceRects_size:Int, indices_array:Int Ptr, indices_size:Int, kerningWidth:Int = 0, pRecti_clipRect:Int = 0, pSColor:Int = 0, bUseAlphaChannelOfTexture:Int = False)	
	Function IrrVideo_IVideoDriver_draw2DImageBatchAtPositions(pIVideoDriver:Int, pITexture:Int, pos_array:Int Ptr, pos_size:Int, sourceRects_array:Int Ptr, sourceRects_size:Int, pRecti_clipRect:Int = 0, pSColor:Int = 0, bUseAlphaChannelOfTexture:Int = False) 

	
	' ---------------------------------------------------------------------------------
	' struct SOverrideMaterial
	' ---------------------------------------------------------------------------------
	Function IrrVideo_SOverrideMaterial_setMaterial(pSOverrideMaterial:Int, pSMaterial:Int)
	
	' do not delete
	Function IrrVideo_SOverrideMaterial_getMaterial:Int(pSOverrideMaterial:Int) ' returns SMaterial*
	Function IrrVideo_SOverrideMaterial_getEnableFlags:Int(pSOverrideMaterial:Int)
	Function IrrVideo_SOverrideMaterial_setEnableFlags(pSOverrideMaterial:Int, enable_flags:Int)
	Function IrrVideo_SOverrideMaterial_getEnablePasses:Short(pSOverrideMaterial:Int)
	Function IrrVideo_SOverrideMaterial_setEnablePasses(pSOverrideMaterial:Int, passes:Short)
	Function IrrVideo_SOverrideMaterial_getEnabled:Int(pSOverrideMaterial:Int)
	Function IrrVideo_SOverrideMaterial_setEnabled(pSOverrideMaterial:Int, bEnabled:Int)
	
EndExtern 