Public

' ! Maximum number of texture an SMaterial can have.  
' NOTE: this can be configured in IrrCompileConfig.h
Global MATERIAL_MAX_TEXTURES:Int = get_MATERIAL_MAX_TEXTURES()
	
'enum E_BLEND_FACTOR
Const EBF_ZERO:Int = 0 					
Const EBF_ONE:Int = 1					
Const EBF_DST_COLOR:Int = 2 			
Const EBF_ONE_MINUS_DST_COLOR:Int = 3 	
Const EBF_SRC_COLOR:Int = 4				
Const EBF_ONE_MINUS_SRC_COLOR:Int = 5 	
Const EBF_SRC_ALPHA:Int = 6				
Const EBF_ONE_MINUS_SRC_ALPHA:Int = 7	
Const EBF_DST_ALPHA:Int = 8				
Const EBF_ONE_MINUS_DST_ALPHA:Int = 9	
Const EBF_SRC_ALPHA_SATURATE:Int = 10	

'enum E_MODULATE_FUNC
Const EMFN_MODULATE_1X:Int	= 1
Const EMFN_MODULATE_2X:Int	= 2
Const EMFN_MODULATE_4X:Int	= 4

' enum E_COMPARISON_FUNC
Const ECFN_NEVER:Int = 0
Const ECFN_LESSEQUAL:Int = 1
Const ECFN_EQUAL:Int = 2
Const ECFN_LESS:Int = 3
Const ECFN_NOTEQUAL:Int = 4
Const ECFN_GREATEREQUAL:Int = 5
Const ECFN_GREATER:Int = 6
Const ECFN_ALWAYS:Int = 7

' enum E_COLOR_PLANE
Const ECP_NONE:Int = 0
Const ECP_ALPHA:Int = 1
Const ECP_RED:Int = 2
Const ECP_GREEN:Int = 4
Const ECP_BLUE:Int = 8
Const ECP_RGB:Int = 14
Const ECP_ALL:Int = 15

' enum E_ALPHA_SOURCE
Const EAS_NONE:Int = 0
Const EAS_VERTEX_COLOR:Int = 1
Const EAS_TEXTURE:Int = 2

' enum E_ANTI_ALIASING_MODE
Const EAAM_OFF:Int = 0
Const EAAM_SIMPLE:Int = 1
Const EAAM_QUALITY:Int = 3
Const EAAM_LINE_SMOOTH:Int = 4
Const EAAM_POINT_SMOOTH:Int = 8
Const EAAM_FULL_BASIC:Int = 15
Const EAAM_ALPHA_TO_COVERAGE:Int = 16

' enum E_COLOR_MATERIAL
Const ECM_NONE:Int = 0
Const ECM_DIFFUSE:Int = 1
Const ECM_AMBIENT:Int = 2
Const ECM_EMISSIVE:Int = 3
Const ECM_SPECULAR:Int = 4
Const ECM_DIFFUSE_AND_AMBIENT:Int = 5

Extern

	Function get_MATERIAL_MAX_TEXTURES:Int()

	' ------------------------------------------------------------------------------------
	'  irr::video::SLight wrappers
	' 
	'  WARNING: do Not Release handles obtained via the get() methods
	' ------------------------------------------------------------------------------------
	
	Function IrrVideo_SMaterial_new:Int() ' returns SMaterial* 
	Function IrrVideo_SMaterial_newFromMaterial:Int(pSMaterial:Int) ' returns SMaterial* 
	Function IrrVideo_SMaterial_del(pSMaterial:Int)
	Function IrrVideo_SMaterial_getMaterialType:Int(pSMaterial:Int) ' returns E_MATERIAL_TYPE
	Function IrrVideo_SMaterial_setMaterialType(pSMaterial:Int,E_MATERIAL_TYPE:Int)
	Function IrrVideo_SMaterial_getMaterialTypeParam:Float(pSMaterial:Int) 
	Function IrrVideo_SMaterial_setMaterialTypeParam(pSMaterial:Int,typeparam:Float)
	Function IrrVideo_SMaterial_getMaterialTypeParam2:Float(pSMaterial:Int) 
	Function IrrVideo_SMaterial_setMaterialTypeParam2(pSMaterial:Int,typeparam:Float)
	Function IrrVideo_SMaterial_getAmbientColor:Int(pSMaterial:Int) ' returns SColor* 
	Function IrrVideo_SMaterial_getDiffuseColor:Int(pSMaterial:Int) ' returns SColor* 
	Function IrrVideo_SMaterial_getEmissiveColor:Int(pSMaterial:Int) ' returns SColor* 
	Function IrrVideo_SMaterial_getSpecularColor:Int(pSMaterial:Int) ' returns SColor* 
	Function IrrVideo_SMaterial_getShininess:Float(pSMaterial:Int)
	Function IrrVideo_SMaterial_setShininess(pSMaterial:Int,newshine:Float)
	Function IrrVideo_SMaterial_getThickness:Float(pSMaterial:Int)
	Function IrrVideo_SMaterial_setThickness(pSMaterial:Int,newthick:Float)
	Function IrrVideo_SMaterial_getWireframe:Int(pSMaterial:Int)
	Function IrrVideo_SMaterial_setWireframe(pSMaterial:Int,bWireFrame:Int)
	Function IrrVideo_SMaterial_getPointCloud:Int(pSMaterial:Int)
	Function IrrVideo_SMaterial_setPointCloud(pSMaterial:Int,bPointCloud:Int)
	Function IrrVideo_SMaterial_getGouraudShading:Int(pSMaterial:Int)
	Function IrrVideo_SMaterial_setGouraudShading(pSMaterial:Int,bNewVal:Int)
	Function IrrVideo_SMaterial_getLighting:Int(pSMaterial:Int)
	Function IrrVideo_SMaterial_setLighting(pSMaterial:Int,bNewVal:Int)
	Function IrrVideo_SMaterial_getZBuffer:Byte(pSMaterial:Int)
	Function IrrVideo_SMaterial_setZBuffer(pSMaterial:Int,bNewVal:Byte)
	Function IrrVideo_SMaterial_getZWriteEnable:Int(pSMaterial:Int)
	Function IrrVideo_SMaterial_setZWriteEnable(pSMaterial:Int,bNewVal:Int)
	Function IrrVideo_SMaterial_getBackfaceCulling:Int(pSMaterial:Int)
	Function IrrVideo_SMaterial_setBackfaceCulling(pSMaterial:Int,bNewVal:Int)
	Function IrrVideo_SMaterial_getFogEnable:Int(pSMaterial:Int)
	Function IrrVideo_SMaterial_setFogEnable(pSMaterial:Int,bNewVal:Int)
	Function IrrVideo_SMaterial_getNormalizeNormals:Int(pSMaterial:Int)
	Function IrrVideo_SMaterial_setNormalizeNormals(pSMaterial:Int,bNewVal:Int)
	Function IrrVideo_SMaterial_getFlag:Int(pSMaterial:Int,idx:Int)
	Function IrrVideo_SMaterial_setFlag(pSMaterial:Int,idx:Int,bNewVal:Int)
	Function IrrVideo_SMaterial_getTexture1:Int(pSMaterial:Int) ' returns ITexture*
	Function IrrVideo_SMaterial_setTexture1(pSMaterial:Int,pITexture:Int)
	Function IrrVideo_SMaterial_getTexture2:Int(pSMaterial:Int) ' returns ITexture* 
	Function IrrVideo_SMaterial_setTexture2(pSMaterial:Int,pITexture:Int)
	Function IrrVideo_SMaterial_getTexture3:Int(pSMaterial:Int) ' returns ITexture* 
	Function IrrVideo_SMaterial_setTexture3(pSMaterial:Int,pITexture:Int)
	Function IrrVideo_SMaterial_getTexture4:Int(pSMaterial:Int) ' returns ITexture* 
	Function IrrVideo_SMaterial_setTexture4(pSMaterial:Int,pITexture:Int)
	Function IrrVideo_SMaterial_getTexture:Int(pSMaterial:Int,idx:Int) ' returns ITexture* 
	Function IrrVideo_SMaterial_setTexture(pSMaterial:Int,idx:Int,pITexture:Int)
	Function IrrVideo_SMaterial_SetEq:Int(pSMaterial:Int,pSMaterial_other:Int) ' returns SMaterial*
	Function IrrVideo_SMaterial_NotEq:Int(pSMaterial:Int,pSMaterial_other:Int)
	
	Function IrrVideo_SMaterial_setTextureMatrix(pSMaterial:Int,idx:Int,pMatrix4:Int)
	Function IrrVideo_SMaterial_getTextureMatrix:Int(pSMaterial:Int,idx:Int) ' returns matrix4*
	Function IrrVideo_SMaterial_isTransparent:Int(pSMaterial:Int)
	Function IrrVideo_SMaterial_getFrontfaceCulling:Int(pSMaterial:Int)
	Function IrrVideo_SMaterial_setFrontfaceCulling(pSMaterial:Int,bNewVal:Int)

	Function IrrVideo_SMaterial_getAntiAliasing:Byte(pSMaterial:Int) 
	Function IrrVideo_SMaterial_setAntiAliasing(pSMaterial:Int,NewVal:Byte)
	Function IrrVideo_SMaterial_getColorMask:Byte(pSMaterial:Int) 
	Function IrrVideo_SMaterial_setColorMask(pSMaterial:Int,NewVal:Byte)
	Function IrrVideo_SMaterial_getColorMaterial:Byte(pSMaterial:Int) 
	Function IrrVideo_SMaterial_setColorMaterial(pSMaterial:Int, NewVal:Byte)
	
EndExtern
